import 'package:anagog_flutter_platform_interface/src/model/micromoment.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'anagog_flutter_method_channel.dart';

abstract class AnagogFlutterPlatform extends PlatformInterface {
  static AnagogFlutterPlatform _instance = AnagogFlutterMethodChannel();
  static final _token = Object();
  static AnagogFlutterPlatform get instance => _instance;

  static set instance(AnagogFlutterPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  AnagogFlutterPlatform() : super(token: _token);

  Future<dynamic> syncCampaigns();
  Future<dynamic> simulateCampaign(String? campaignIdentifier);
  Stream<dynamic> obtainEventStream();
  Future<dynamic> setUserDefinedString(Map<String, dynamic> arguments);
  Future<String?> getUserDefinedString(String name);
  Future<dynamic> setUserDefinedInteger(Map<String, dynamic> arguments);
  Future<int?> getUserDefinedInteger(String name);
  Future<dynamic> setUserDefinedDecimal(Map<String, dynamic> arguments);
  Future<double?> getUserDefinedDecimal(String name);
  Future<dynamic> getVersion();
  Future<Map<dynamic, dynamic>?> getUserDefinedStat();
  Future<dynamic> fireMicromoments(Micromoment micromoment);
  Future<dynamic> requestMicrosegmentsSnapshotReport();
  Future<dynamic> share();
}
